   /*
 Ali Nouri Zonoz   CMU
 July 2016

 */
   /*
 Ali Nouri Zonoz   CMU
 July 2017

 */

 #ifdef __linux__
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#elif defined(_WIN32) || defined(_WIN64)

#endif

 #include <iostream>

 #include "dynamixel_sdk/dynamixel_sdk.h"  
#include <pthread.h>
#include <vector>
#include <stdio.h>
#include <unistd.h>
#include <thread>
#include <stdlib.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <fstream>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <stdint.h>
#include <netinet/in.h>
#include <time.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <opencv2/core/core.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <iostream>
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/opencv.hpp"
#include "opencv2/video.hpp"
#include "opencv2/highgui.hpp"
#include <vector>
#include <atomic>
#define BUFSIZE 	2000
#define NUM_THREADS    4
#define SERVERPORT   "30313"
#define SERVERPORTARD "2390"
#define THRESH                        20

#define ADDR_MX_TORQUE_ENABLE           24                  // Control table address is different in Dynamixel model
#define ADDR_MX_GOAL_POSITION           30
#define ADDR_MX_PRESENT_POSITION        36

// Protocol version
#define PROTOCOL_VERSION                1.0                 // See which protocol version is used in the Dynamixel

// Default setting
#define DXL_ID                          1                // Dynamixel ID: 1
#define DXL_IDD                          2                // Dynamixel ID: 1

#define BAUDRATE                        2000000
#define DEVICENAME                      "/dev/ttyUSB0"      // Check which port is being used on your controller
                                                            // ex) Windows: "COM1"   Linux: "/dev/ttyUSB0"
#define LEN_MX_GOAL_POSITION            2
#define LEN_MX_PRESENT_POSITION         2
#define TORQUE_ENABLE                   1                   // Value for enabling the torque
#define TORQUE_DISABLE                  0                   // Value for disabling the torque
#define DXL_MINIMUM_POSITION_VALUE      100                 // Dynamixel will rotate between this value
#define DXL_MAXIMUM_POSITION_VALUE      4000                // and this value (note that the Dynamixel would not move when the position value is out of movable range. Check e-manual about the range of the Dynamixel you use.)
#define DXL_MOVING_STATUS_THRESHOLD     1                 // Dynamixel moving status threshold

#define ESC_ASCII_VALUE                 0x1b


using namespace cv;
using namespace std;

//********************************************************************************************* Defining Global Variables ******************************************************************************************//
//******************************************************************************************************************************************************************************************************************//
//******************************************************************************************************************************************************************************************************************//
std::atomic<int> go0;
std::atomic <int> go1;
std::atomic <int> go2;
std::atomic <int> go3;
std::atomic <int> go4;
std::atomic <bool> go5;
std::atomic <bool> LEDON;

int  closeupA=0;
int  closeupB=0;
int closeuplens=0;
int capcon=0;
Mat IMG,IMG2;
string dataname;
int closeupimg=0;
int liveimg=0;
//Mats for 2D drawu=ing
Mat imgLines1 = Mat::zeros( 512,640, CV_8UC3 );
Mat imgLines2 = Mat::zeros( 512,640, CV_8UC3 );
Mat imgLines3 = Mat::zeros( 512,640, CV_8UC3 );
Mat imgLines  = Mat::zeros( 512,640, CV_8UC3 );
Mat imgtmp;
//Input: Camera Matrix





Mat mA=(Mat_<float>(3,3) <<     4.7196752617729146e+02, 0, 3.1550000000000000e+02, 0,  4.7196752617729146e+02, 2.5350000000000000e+02, 0, 0, 1);
Mat mB=(Mat_<float>(3,3) <<     4.6829512161424498e+02, 0, 3.1550000000000000e+02, 0, 4.6829512161424498e+02, 2.5350000000000000e+02, 0, 0, 1);
Mat mC=(Mat_<float>(3,3) <<     4.6996008656064788e+02, 0, 3.1550000000000000e+02, 0,  4.6996008656064788e+02, 2.5350000000000000e+02, 0, 0, 1);
Mat mD=(Mat_<float>(3,3) <<     4.6996008656064788e+02, 0, 3.1550000000000000e+02, 0,  4.6996008656064788e+02, 2.5350000000000000e+02, 0, 0, 1);

//Input: Distortion Coefficients
Mat dA=(Mat_<float>(1,4) << -3.3578247297666314e-01, 2.2743674110178400e-01, 0, 0);// -2.3704722217306959e+00);//-8.8204262039829340e-01
Mat dB=(Mat_<float>(1,4) << -3.5506069843837201e-01, 2.4759143015216020e-01, 0, 0);// -2.3830747931546445e-01
Mat dC=(Mat_<float>(1,4) << -3.2842997314171629e-01, 1.6718837850893636e-01, 0, 0);
Mat dD=(Mat_<float>(1,4) << -3.2842997314171629e-01, 1.6718837850893636e-01, 0, 0);

Mat M1= (Mat_<float>(3,4)<<1, 0, 0, 0, 0, 1, 0, 0,0, 0, 1, 0);
Mat M2= (Mat_<float>(3,4)<<0.53082788,0.590020716, -0.608356237, 0.634907067, -0.75696063, 0.00729430281, -0.653419793, 0.589374125, -0.381093651, 0.807355165, 0.450494438, 0.499531001  );
Mat M3= (Mat_<float>(3,4)<<0.0259479899,-0.409260273, -0.912048638, 0.990634561, -0.381702423, -0.847284853, 0.369339526, -0.175138205, -0.923920989, 0.338547558, -0.178200975, 1.16916335 );
Mat M4= (Mat_<float>(3,4)<<-0.25069949, 0.708015919, 0.660199404, -0.717393637, -0.75171417, 0.287339032, -0.593600929, 0.690364003, -0.609979928, -0.645096719, 0.460189849, 0.57086134  );
//Mats for Rotation,Transition and Mask Matrix

Mat aff = (Mat_<float>(3,4)<<-286.203552, -256.135803, -259.847198, 352.258331, 134.398056, -371.985474, 244.147568, -188.810165, 348.136444, -81.4486923, -301.568756, 279.643372  );
//Mats for Rotation,Transition and Mask Matrix


//Mat output of Triangulation

Point3f output3d;
 Mat P4DR(4,1,CV_32FC1, Scalar::all(0));
 Mat P4DrealR(3,1,CV_32FC1, Scalar::all(0));
  Mat P4DB(4,1,CV_32FC1, Scalar::all(0));
 Mat P4DrealB(3,1,CV_32FC1, Scalar::all(0));
   Mat P4DG(4,1,CV_32FC1, Scalar::all(0));
 Mat P4DrealG(3,1,CV_32FC1, Scalar::all(0));
  Mat PastB(4,1,CV_32FC1, Scalar::all(0));
   Mat PastR(4,1,CV_32FC1, Scalar::all(0));
Mat dst,src;
//Integers and others..
int globalplot=0;
int liveshow=0;							//gnuplot starting
int row=0;							//control for data collection
int done=0;        						//control of stopping gnuplot
int posX2R,posY2R,posX1R,posY1R,posY3R,posX3R,posX4R,posY4R,posY6R,posX6R,posX5R,posY5R;
int posX2B,posY2B,posX1B,posY1B,posY3B,posX3B,posX4B,posY4B,posY6B,posX6B,posX5B,posY5B;
int posX2G,posY2G,posX1G,posY1G,posY3G,posX3G,posX4G,posY4G,posY6G,posX6G,posX5G,posY5G;
int T1,T2,T3,T4;							//2D positions received from both cameras
int iLastX1,iLastX2,iLastY1,iLastY2,iLastY3,iLastX3;				//Values for 2D drawing
//float w; 							//PD4
double focal = mA.at<float>(0,0); 				// focal length
Point2d pp(mA.at<float>(0,2), mA.at<float>(1,2)); 		//principal point
int neural=0;
int neocond=1;
int ms;
int mspast;
int counttwo=0;
Point3f POSred,POSFED1,Mouse;
Point3f ConPlace;
struct timeval tp1,tp2,tp3,tp4,tp5,tp6,tj1,tj2,tpnow,tpprev,tpf1,tpf2;
int CKL=0;
int deliver=0;
Mat mylivecam;

 Mat Position_per(3,1,CV_32FC1, Scalar::all(0));
  Mat SumDist(3 ,1,CV_32FC1, Scalar::all(0));
   Mat SumDistT(1 ,3,CV_32FC1, Scalar::all(0));
   Mat AcDist(1 ,1,CV_32FC1, Scalar::all(0));
//Mat res(200, 400,CV_8UC1, Scalar::all(0));
 Mat3b res(200, 400, Vec3b(0,0,0));
int S=0;
vector<cv::Point3f> first, second;
std::vector<uchar> inliers;
//cv::Mat aff(3,4,CV_64F);




// File to write the 3d positions
ofstream myfile,myfile2;
ofstream timeandpos;
ofstream dot;
ofstream plotingdata;
ofstream samplee;
float Distance=100;
int countt=0;
// Vectors for storing the collected data used in recoverpose and find essentialMat function
vector<Point2f> objAR(1);
vector<Point2f> objBR(1);
vector<Point2f> objCR(1);
vector<Point2f> objDR(1);
vector<Point2f> objER(1);
vector<Point2f> objFR(1);
vector<Point2f> objA_undistR(1);
vector<Point2f> objB_undistR(1);
vector<Point2f> objC_undistR(1);
vector<Point2f> objD_undistR(1);
vector<Point2f> objE_undistR(1);
vector<Point2f> objF_undistR(1);




vector<Point2f> objAB(1);
vector<Point2f> objBB(1);
vector<Point2f> objCB(1);
vector<Point2f> objDB(1);
vector<Point2f> objEB(1);
vector<Point2f> objFB(1);
vector<Point2f> objA_undistB(1);
vector<Point2f> objB_undistB(1);
vector<Point2f> objC_undistB(1);
vector<Point2f> objD_undistB(1);
vector<Point2f> objE_undistB(1);
vector<Point2f> objF_undistB(1);




vector<Point2f> objAG(1);
vector<Point2f> objBG(1);
vector<Point2f> objCG(1);
vector<Point2f> objDG(1);
vector<Point2f> objEG(1);
vector<Point2f> objFG(1);
vector<Point2f> objA_undistG(1);
vector<Point2f> objB_undistG(1);
vector<Point2f> objC_undistG(1);
vector<Point2f> objD_undistG(1);
vector<Point2f> objE_undistG(1);
vector<Point2f> objF_undistG(1);

vector<Mat> projMatr (4);
Mat imgcap,imgcap2,dst2;
int Mstate=0;
Mat imgreal;
FILE *file;
float FFF;
ofstream latency;

Size size(200,200);
Size size2(640,512);
int XX=46;int YY=145;int ZZ=92;
float X,Y,Z=0;
float x=0.0;
float y=0.0;
float z=0.0;
float AA=0.0;
float BB=0.0;
float CC=0.0;
float A=0.0;
int AF=0.0;
int inA=0.0;
float B=0.0;
int BF=0.0;
int inB=0.0;
int AF2=0;
float CC2=0.0;
float A2=0.0;
float AA2=0.0;
float OFD=0.0; 
float GG;
float focus=0;
float shit;
float shit2;
float B2=0.0;
int BF2=0.0;
float BB2=0.0;
int starttr=0;
int ms_speed=0;
int reward=0;
int click=0;
int dxl_comm_result = COMM_TX_FAIL;             // Communication result
		int dxl_comm_result2 = COMM_TX_FAIL;
		uint8_t dxl_error = 0;                          // Dynamixel error
		uint16_t dxl_present_position = 0;
		uint8_t param_goal_position[2];
		uint8_t param_goal_position2[2];
		uint8_t param_goal_Lposition[2];
		uint8_t param_goal_Lposition2[2];
		bool dxl_addparam_result = false;  
		dynamixel::PortHandler *portHandler = dynamixel::PortHandler::getPortHandler(DEVICENAME);
		
		dynamixel::PacketHandler *packetHandler = dynamixel::PacketHandler::getPacketHandler(PROTOCOL_VERSION);
		dynamixel::GroupSyncWrite groupSyncWrite(portHandler, packetHandler, ADDR_MX_GOAL_POSITION, LEN_MX_GOAL_POSITION);
		int plotcount=0;
			int ffR=0;
	int ffB=0;
	int ffG=0;
		
		//FILE *file;
//Mat X;
//********************************************************************************************* Functions **********************************************************************************************************//
//******************************************************************************************************************************************************************************************************************//
//******************************************************************************************************************************************************************************************************************//
 float calcdist(cv::Point3f A, cv::Point3f B)
{
	float Dist=float ( sqrt (  (A.x-B.x)*(A.x-B.x) +  (A.y-B.y)*(A.y-B.y) + (A.z-B.z)*(A.z-B.z)     ) );
	return Dist;
}
float calcdist2D(cv::Point3f A, cv::Point3f B)
{
 float Dist =sqrt (  (A.x-B.x)*(A.x-B.x) +  (A.y-B.y)*(A.y-B.y));
 return Dist;
}
void set_realtime_priority()
{
	int ret;
	pthread_t this_thread=pthread_self();
	struct sched_param params;
	params.sched_priority=sched_get_priority_max(SCHED_FIFO);
	ret=pthread_setschedparam(this_thread,SCHED_FIFO,&params);
}
int Triangulate(const vector<Mat> projMatr, const vector<int> index, const vector<Point2f> projPoints, Mat& X)
{
/* parameters
   - projMatr : list of all 3x4 camera matrices
   - index : list of cam numbers corresponding to projections
   - projPoints : list of 2D image projections
   - points3D : triangulated 3D point (output)
*/

    // Check if enough views to triangulate
    int nviews=index.size();
    if (nviews<2) return(0);

    Mat A, P, r;
    float x,y;

    // Fill matrix A
    for( int j = 0; j < nviews; j++ ) {

     // get image projection
     x = (float) projPoints[j].x;
     y = (float) projPoints[j].y;

     // get corresponding cam matrix
     P = projMatr[index[j]];

     // add 3 lines to A (cf HZ book chap 12.2 p312)reference camera with more tha 2 views 3d
     r = P.row(2)*x - P.row(0); A.push_back(r);
     r = P.row(2)*y - P.row(1); A.push_back(r);
   // r = x*P.row(1) - y*P.row(0);  A.push_back(r); // redundant
    }

    // Solve homogenous system AX=0 with |X|=1, using Singular Value Decomposition
    // ref  Hartley&Zissermann book p592
    SVD::solveZ(A, X);

    // Perform reweighting and iterate solving to increase accuracy
    // ref Hartley&Sturm 1997 paper "Triangulation", Iterative-Eigen method
  /* float w;
    for (int c=0; c<5; c++) { // iterate 5 times
         for( int j = 0; j < nviews; j++ ) {
         int i=2*j;
         r = projMatr[index[j]].row(2)*X;
         w=r.at<float>(0);
         if (abs(w)<1e-6) break;
         w=1/w;
         r=A.row(i); A.row(i)=r*w;
         r=A.row(i+1); A.row(i+1)=r*w;
         }
         SVD::solveZ(A, X);
    }*/
	//cout<<X<<endl<<endl<<endl;
    if (!checkRange(X) || X.at<float>(3)==0) {
    cout << "SVD algorithm error" << endl;
     return(0);
    }
    else {
    // return real (inhomogeneous) 3D point
     X.at<float>(0) = X.at<float>(0) / X.at<float>(3);
     X.at<float>(1) = X.at<float>(1) / X.at<float>(3);
     X.at<float>(2) = X.at<float>(2) / X.at<float>(3);
     X.at<float>(3) = X.at<float>(3) / X.at<float>(3);
    }

    return(1);
}
//Error function for UDP
void error(char *msg) {
  perror(msg);
  exit(1);
}

//Thread function
void *Track(void *threadid)
 {
    long tid;
    tid = (long)threadid;

    //Jetson 1- Working on port 8080 //********************* tid=0 **********************//
    if(tid==0){
    	struct sockaddr_in serveraddr; /* server's addr */
    	struct sockaddr_in clientaddr; /* client addr */
    	struct hostent *hostp; /* client host info */
    	int sockfd; /* socket */
    	int portno; /* port to listen on */
    	socklen_t clientlen;
    	char *hostaddrp; /* dotted decimal host addr string */
	int optval; /* flag value for setsockopt */
	int n; /* message byte size */
	sockfd = socket(AF_INET, SOCK_DGRAM, 0);
	portno = atoi("1010");
	optval = 1;
	setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR,(const void *)&optval , sizeof(int));
	bzero((char *) &serveraddr, sizeof(serveraddr));
	serveraddr.sin_family = AF_INET;
	serveraddr.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr.sin_port = htons((unsigned short)portno);
	int b=bind(sockfd, (struct sockaddr *) &serveraddr, sizeof(serveraddr));
	clientlen = sizeof(clientaddr);
	int buf1[BUFSIZE];
	sleep(1);
	int cc1=0;
	cout<<"Kernel Thread zero ready to receive..."<<endl;
	while(1)
	{


	  //  buf1[0]=0;
	  //  buf1[1]=0;
	    n = recvfrom(sockfd, buf1, BUFSIZE, 0,(struct sockaddr *) &clientaddr, &clientlen);
	    
            posX1R = (buf1[0]);
	    posY1R = (buf1[1]);
	    posX1B = (buf1[2]);
	    posY1B = (buf1[3]);
	    posX1G = (buf1[4]);
	    posY1G = (buf1[5]);
	    
	    go0=1;
	  //  }
	   // T1=(buf1[2]);
	  //  cc1=cc1+1;
	 //   cout<<cc1<<endl;
		


	}
	pthread_exit(NULL);
    }

    //Jetson 2- Working on port 9090 //********************* tid=1 **********************//
    if(tid==1){
    	struct sockaddr_in serveraddr2; /* server's addr */
    	struct sockaddr_in clientaddr2; /* client addr */
    	struct hostent *hostp2; /* client host info */
    	int sockfd2; /* socket */
    	int portno2; /* port to listen on */
    	socklen_t clientlen2;
    	char *hostaddrp2; /* dotted decimal host addr string */
	int optval2; /* flag value for setsockopt */
	int n2; /* message byte size */
	sockfd2 = socket(AF_INET, SOCK_DGRAM, 0);
	portno2 = atoi("2020");
	optval2 = 1;
	setsockopt(sockfd2, SOL_SOCKET, SO_REUSEADDR,(const void *)&optval2 , sizeof(int));
	bzero((char *) &serveraddr2, sizeof(serveraddr2));
	serveraddr2.sin_family = AF_INET;
	serveraddr2.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr2.sin_port = htons((unsigned short)portno2);
	int b=bind(sockfd2, (struct sockaddr *) &serveraddr2, sizeof(serveraddr2));
	clientlen2 = sizeof(clientaddr2);
	 int buf2[BUFSIZE];
	sleep(1);
	cout<<"Kernel Thread one ready to receive..."<<endl;

	while(1)
	{


	    n2 = recvfrom(sockfd2, buf2, BUFSIZE, 0,(struct sockaddr *) &clientaddr2, &clientlen2);
	  //  if(n2>0){
	      posX2R = (buf2[0]);
	    posY2R = (buf2[1]);
	    posX2B = (buf2[2]);
	    posY2B = (buf2[3]);
	    posX2G = (buf2[4]);
	    posY2G = (buf2[5]);
	    
	    
	    go1=1;
	 //   }
	   // T2=(buf2[2]);
	    //cc2=cc2+1;



	}
	pthread_exit(NULL);
    }


    if(tid==2){
    	struct sockaddr_in serveraddr3; /* server's addr */
    	struct sockaddr_in clientaddr3; /* client addr */
    	struct hostent *hostp3; /* client host info */
    	int sockfd3; /* socket */
    	int portno3; /* port to listen on */
    	socklen_t clientlen3;
    	char *hostaddrp3; /* dotted decimal host addr string */
	int optval3; /* flag value for setsockopt */
	int n3; /* message byte size */
	sockfd3 = socket(AF_INET, SOCK_DGRAM, 0);
	portno3 = atoi("3030");
	optval3 = 1;
	setsockopt(sockfd3, SOL_SOCKET, SO_REUSEADDR,(const void *)&optval3 , sizeof(int));
	bzero((char *) &serveraddr3, sizeof(serveraddr3));
	serveraddr3.sin_family = AF_INET;
	serveraddr3.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr3.sin_port = htons((unsigned short)portno3);
	int b=bind(sockfd3, (struct sockaddr *) &serveraddr3, sizeof(serveraddr3));
	clientlen3 = sizeof(clientaddr3);
	 int buf3[BUFSIZE];
	sleep(1);
	cout<<"Kernel Thread one ready to receive..."<<endl;

	while(1)
	{

	    n3 = recvfrom(sockfd3, buf3, BUFSIZE,0,(struct sockaddr *) &clientaddr3, &clientlen3);
	  //  if(n3>0){
	    posX3R = (buf3[0]);
	    posY3R = (buf3[1]);
	    posX3B = (buf3[2]);
	    posY3B = (buf3[3]);
	    posX3G = (buf3[4]);
	    posY3G = (buf3[5]);
	    go2=1;
	 //   }
	   // T3=(buf3[2]);
	   // cc3=cc3+1;


	}
	pthread_exit(NULL);
    }


    //GNUplot Working on thread 2 - using System call for running bash //*********** tid2 ************//
    if(tid==33){
    
   	 	while(globalplot==0)
		{}
		//while(1){}
		system(" ./dirplot.sh -e");
	
     }

  if(tid==3){

	struct sockaddr_in serveraddr4; /* server's addr */
    	struct sockaddr_in clientaddr4; /* client addr */
    	struct hostent *hostp4; /* client host info */
    	int sockfd4; /* socket */
    	int portno4; /* port to listen on */
    	socklen_t clientlen4;
    	char *hostaddrp4; /* dotted decimal host addr string */
	int optval4; /* flag value for setsockopt */
	int n4; /* message byte size */
	sockfd4 = socket(AF_INET, SOCK_DGRAM, 0);
	portno4 = atoi("4040");
	optval4 = 1;
	setsockopt(sockfd4, SOL_SOCKET, SO_REUSEADDR,(const void *)&optval4 , sizeof(int));
	bzero((char *) &serveraddr4, sizeof(serveraddr4));
	serveraddr4.sin_family = AF_INET;
	serveraddr4.sin_addr.s_addr = htonl(INADDR_ANY);
	serveraddr4.sin_port = htons((unsigned short)portno4);
	int b4=bind(sockfd4, (struct sockaddr *) &serveraddr4, sizeof(serveraddr4));
	clientlen4 = sizeof(clientaddr4);
	 int buf4[BUFSIZE];
	sleep(1);
	cout<<"Kernel Thread one ready to receive..."<<endl;
	while(1)
	{

	    n4 = recvfrom(sockfd4, buf4, BUFSIZE, 0,(struct sockaddr *) &clientaddr4, &clientlen4);
	  //  if(n4>0){
 	     posX4R = (buf4[0]);
	    posY4R = (buf4[1]);
	    posX4B = (buf4[2]);
	    posY4B = (buf4[3]);
	    posX4G = (buf4[4]);
	    posY4G = (buf4[5]);
	    go3=1;
	  //  }
	   // T4=(buf4[2]);
	    


	}
	pthread_exit(NULL);
     }



     
   
 
 }

// **************************************************************************************************** Main Function *************************************************************************************************//
int main(int argc, char **argv) {


	cout<<"are you sure about removing datapic?"<<endl;
	int AAAA;	
	cin>>AAAA;
	if(AAAA!=1111)
		return 0;
	system("rm -r DATAPIC");
	system ("mkdir DATAPIC");

	int sockfd;
	struct addrinfo hints, *servinfo, *p;
	int rv;
	int numbytes;
	const char* message="";
	memset(&hints, 0, sizeof hints);
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_DGRAM;

	if ((rv = getaddrinfo("lens", SERVERPORT, &hints, &servinfo)) != 0) {
		fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(rv));
		//return 1;
	}

	// loop through all the results and make a socket
	for(p = servinfo; p != NULL; p = p->ai_next) {
		if ((sockfd = socket(p->ai_family, p->ai_socktype,
		p->ai_protocol)) == -1) {
			perror("talker: socket");
			continue;
	}

		break;
	}

	if (p == NULL) {
		fprintf(stderr, "talker: failed to create socket\n");
		//return 2;
	}





	if (portHandler->openPort())
		printf("Succeeded to open the port!\n");
	 
	else
	{
	   	printf("Failed to open the port!\n");
	    	printf("Press any key to terminate...\n");

	}

	  // Set port baudrate
	if (portHandler->setBaudRate(BAUDRATE))
	    	printf("Succeeded to change the baudrate!\n");

	else
	    	printf("Failed to change the baudrate!\n");


	

	dxl_comm_result = packetHandler->write1ByteTxRx(portHandler, DXL_ID, ADDR_MX_TORQUE_ENABLE, TORQUE_ENABLE, &dxl_error);
	dxl_comm_result2 = packetHandler->write1ByteTxRx(portHandler, DXL_IDD, ADDR_MX_TORQUE_ENABLE, TORQUE_ENABLE, &dxl_error);


	 
	if (dxl_comm_result2 != COMM_SUCCESS)
		packetHandler->getTxRxResult(dxl_comm_result);

	else if (dxl_error != 0)
		packetHandler->getRxPacketError(dxl_error);

	else
		printf("Dynamixel has been successfully connected \n");
       


	myfile.open ("DATAPIC/data.txt");
myfile2.open ("dataplt.txt");
       
       	
	
       
       
       
        // Creating 3 threads
       
       
       
        int rc;
	long tt;



	pthread_t threads[NUM_THREADS];
	for(tt=0; tt<NUM_THREADS; tt++){
		printf("In main: creating thread %ld\n", tt);
		rc = pthread_create(&threads[tt], NULL, Track, (void *)tt);
		//sleep(0.5);
		if (rc)
	  		printf("ERROR in Creating threads..");

	}
	
	float SI=1;
	usleep(3000000);
	//
 	// proper camera matrix for Triangulate function is K*[R|t]
   	projMatr[0]=mA*M1;
	projMatr[1]=mB*M2;
 	projMatr[2]=mC*M3;
	projMatr[3]=mD*M4;

	float Velocity;
  	
	cout<<"Tracking started..."<<endl;
	//cin>>S;
	int ff=0;
	float minx,miny,minz,maxx,maxy,maxz;
	time_t start, end,triang_time;
	liveshow=1;
	gettimeofday(&tp1,NULL);
	int interval;
        
	 //Mat sampletime = imread("bike.jpg");  
	int Oc=0;
	int Tc=0;
	int GGG=450;
	gettimeofday(&tp1,NULL);
float NewX;

	while(1){
	
		
		gettimeofday(&tp4,NULL);
		while ((go1+go2+go3+go0<4))
		{
			
			gettimeofday(&tp5,NULL);
			unsigned long msch= 1000000*(tp5.tv_sec-tp4.tv_sec)+(tp5.tv_usec-tp4.tv_usec) ;
			if((go1+go2+go3+go0>1) & msch>2000){
				//cout<<"hi"<<endl;
				break;
				}
			
		}
		
		//usleep(1200);
		Oc=Oc+1;
		go0=0;
		go1=0;
		go2=0;
	        go3=0;

		vector<Point2f> projPointsR;
		vector<int> indexxxR;
		
		vector<Point2f> projPointsB;
		vector<int> indexxxB;
		
		vector<Point2f> projPointsG;
		vector<int> indexxxG;
		

		//cin>>S;

		//if(TT1!=T1){
		objAR[0].x=posX1R;
		objAR[0].y=posY1R;
		//}
		
		//if(TT2!=T2){
		objBR[0].x=posX2R;
		objBR[0].y=posY2R;
		//}
		//if(TT3!=T3){
		objCR[0].x=posX3R;
		objCR[0].y=posY3R;
		//}
		//if(TT4!=T4){
		objDR[0].x=posX4R;
		objDR[0].y=posY4R;
		

		
		
		
		
		objAB[0].x=posX1B;
		objAB[0].y=posY1B;
		//}
		
		//if(TT2!=T2){
		objBB[0].x=posX2B;
		objBB[0].y=posY2B;
		//}
		//if(TT3!=T3){
		objCB[0].x=posX3B;
		objCB[0].y=posY3B;
		//}
		//if(TT4!=T4){
		objDB[0].x=posX4B;
		objDB[0].y=posY4B;
		//}

	        
	       	        
	        objAG[0].x=posX1G;
		objAG[0].y=posY1G;
		//}
		
		//if(TT2!=T2){
		objBG[0].x=posX2G;
		objBG[0].y=posY2G;
		//}
		//if(TT3!=T3){
		objCG[0].x=posX3G;
		objCG[0].y=posY3G;
		//}
		//if(TT4!=T4){
		objDG[0].x=posX4G;
		objDG[0].y=posY4G;
		
		
	

	
		undistortPoints(objAR, objA_undistR, mA, dA);
		undistortPoints(objBR, objB_undistR, mB, dB);
		undistortPoints(objCR, objC_undistR, mC, dC);
		undistortPoints(objDR, objD_undistR, mD, dD);

		
		
		undistortPoints(objAB, objA_undistB, mA, dA);
		undistortPoints(objBB, objB_undistB, mB, dB);
		undistortPoints(objCB, objC_undistB, mC, dC);
		undistortPoints(objDB, objD_undistB, mD, dD);		

		undistortPoints(objAG, objA_undistG, mA, dA);
		undistortPoints(objBG, objB_undistG, mB, dB);
		undistortPoints(objCG, objC_undistG, mC, dC);
		undistortPoints(objDG, objD_undistG, mD, dD);



		objA_undistR[0].x = objA_undistR[0].x* mA.at<float>(0, 0) + mA.at<float>(0, 2);
		objA_undistR[0].y = objA_undistR[0].y* mA.at<float>(1, 1) + mA.at<float>(1, 2);
		objB_undistR[0].x = objB_undistR[0].x* mB.at<float>(0, 0) + mB.at<float>(0, 2);
		objB_undistR[0].y = objB_undistR[0].y* mB.at<float>(1, 1) + mB.at<float>(1, 2);
		objC_undistR[0].x = objC_undistR[0].x* mC.at<float>(0, 0) + mC.at<float>(0, 2);
		objC_undistR[0].y = objC_undistR[0].y* mC.at<float>(1, 1) + mC.at<float>(1, 2);
		objD_undistR[0].x = objD_undistR[0].x* mD.at<float>(0, 0) + mD.at<float>(0, 2);
		objD_undistR[0].y = objD_undistR[0].y* mD.at<float>(1, 1) + mD.at<float>(1, 2);


		
		objA_undistB[0].x = objA_undistB[0].x* mA.at<float>(0, 0) + mA.at<float>(0, 2);
		objA_undistB[0].y = objA_undistB[0].y* mA.at<float>(1, 1) + mA.at<float>(1, 2);
		objB_undistB[0].x = objB_undistB[0].x* mB.at<float>(0, 0) + mB.at<float>(0, 2);
		objB_undistB[0].y = objB_undistB[0].y* mB.at<float>(1, 1) + mB.at<float>(1, 2);
		objC_undistB[0].x = objC_undistB[0].x* mC.at<float>(0, 0) + mC.at<float>(0, 2);
		objC_undistB[0].y = objC_undistB[0].y* mC.at<float>(1, 1) + mC.at<float>(1, 2);
		objD_undistB[0].x = objD_undistB[0].x* mD.at<float>(0, 0) + mD.at<float>(0, 2);
		objD_undistB[0].y = objD_undistB[0].y* mD.at<float>(1, 1) + mD.at<float>(1, 2);


		objA_undistG[0].x = objA_undistG[0].x* mA.at<float>(0, 0) + mA.at<float>(0, 2);
		objA_undistG[0].y = objA_undistG[0].y* mA.at<float>(1, 1) + mA.at<float>(1, 2);
		objB_undistG[0].x = objB_undistG[0].x* mB.at<float>(0, 0) + mB.at<float>(0, 2);
		objB_undistG[0].y = objB_undistG[0].y* mB.at<float>(1, 1) + mB.at<float>(1, 2);
		objC_undistG[0].x = objC_undistG[0].x* mC.at<float>(0, 0) + mC.at<float>(0, 2);
		objC_undistG[0].y = objC_undistG[0].y* mC.at<float>(1, 1) + mC.at<float>(1, 2);
		objD_undistG[0].x = objD_undistG[0].x* mD.at<float>(0, 0) + mD.at<float>(0, 2);
		objD_undistG[0].y = objD_undistG[0].y* mD.at<float>(1, 1) + mD.at<float>(1, 2);


		//globalplot=0;

		int xxxR=0;
		int xxxB=0;
		int xxxG=0;
		


		if(objAR[0].x!=0 & objAR[0].y!=0)
		{
			xxxR=0;
			indexxxR.push_back(xxxR);
			projPointsR.push_back(objA_undistR[0]);
			
		}


		if(objBR[0].x!=0 & objBR[0].y!=0)
		{
			xxxR=1;
			indexxxR.push_back(xxxR);
			projPointsR.push_back(objB_undistR[0]);
			
		}

		if(objCR[0].x!=0 & objCR[0].y!=0)
		{
			xxxR=2;
			indexxxR.push_back(xxxR);
			projPointsR.push_back(objC_undistR[0]);
			
		}
		if(objDR[0].x!=0 & objDR[0].y!=0)
		{
			xxxR=3;
			indexxxR.push_back(xxxR);
			projPointsR.push_back(objD_undistR[0]);
			
		}
		

		
//////////////////////////////////////////		
		if(objAB[0].x!=0 & objAB[0].y!=0)
		{
			xxxB=0;
			indexxxB.push_back(xxxB);
			projPointsB.push_back(objA_undistB[0]);


		}


		if(objBB[0].x!=0 & objBB[0].y!=0)
		{
			xxxB=1;
			indexxxB.push_back(xxxB);
			projPointsB.push_back(objB_undistB[0]);
			
		}

		if(objCB[0].x!=0 & objCB[0].y!=0)
		{
			xxxB=2;
			indexxxB.push_back(xxxB);
			projPointsB.push_back(objC_undistB[0]);

		}
		if(objDB[0].x!=0 & objDB[0].y!=0)
		{
			xxxB=3;
			indexxxB.push_back(xxxB);
			projPointsB.push_back(objD_undistB[0]);
			
		}
		





		if(objAG[0].x!=0 & objAG[0].y!=0)
		{
			xxxG=0;
			indexxxG.push_back(xxxG);
			projPointsG.push_back(objA_undistG[0]);
			
		}



		if(objBG[0].x!=0 & objBG[0].y!=0)
		{
			xxxG=1;
			indexxxG.push_back(xxxG);
			projPointsG.push_back(objB_undistG[0]);
			
		}

		if(objCG[0].x!=0 & objCG[0].y!=0)
		{
			xxxG=2;
			indexxxG.push_back(xxxG);
			projPointsG.push_back(objC_undistG[0]);
			
		}
		if(objDG[0].x!=0 & objDG[0].y!=0)
		{
			xxxG=3;
			indexxxG.push_back(xxxG);
			projPointsG.push_back(objD_undistG[0]);
			
		}


		
		//if(posX1R>0)
		cout<<posX1R<<" "<<posX2R<<" "<<posX3R<<" "<<posX4R<<endl<<"   "<<posX1B<<" "<<posX2B<<" "<<posX3B<<" "<<posX4B<<endl<<posX1G<<" "<<posX2G<<" "<<posX3G<<" "<<posX4G<<endl<<endl<<endl;
		
		
		
		
		if(indexxxB.size()>1)
		{
		
			ffB=ffB+1;
				
			int NN=Triangulate(projMatr, indexxxB,projPointsB,P4DB);	
			P4DrealB=aff*P4DB;
			
		    
	    	}
	    	
	    	if(indexxxG.size()>1)
		{
		
			ffG=ffG+1;
				
			int NN=Triangulate(projMatr, indexxxG,projPointsG,P4DG);	
			P4DrealG=aff*P4DG;
			
		    
	    	}
	    	
	    	if(indexxxR.size()>1){
			

			ffR=ffR+1;
			
			
			
			int NN=Triangulate(projMatr, indexxxR,projPointsR,P4DR);
			P4DrealR=aff*P4DR;
			gettimeofday(&tp2,NULL);
			unsigned long ms2= 1000000*(tp2.tv_sec-tp1.tv_sec)+(tp2.tv_usec-tp1.tv_usec);

			

	    	}
		
			

	}
	
	return 0;
		


        }



       
        



